<template>
    <div class="payment">
        <v-row
            :class="[
                { 'pl-5 pr-5': $vuetify.breakpoint.smAndDown },
                { 'pl-16 pr-16': $vuetify.breakpoint.mdAndUp },
            ]"
        >
            <v-col v-if="$vuetify.breakpoint.mdAndUp" cols="3">
                <menu-bar />
            </v-col>
            <v-col>
                <v-row
                    :class="[
                        { 'pt-16 pl-0 pr-0': $vuetify.breakpoint.smAndDown },
                        { 'pl-16 pr-16': $vuetify.breakpoint.mdAndUp },
                    ]"
                >
                    <v-col>
                        <h1 class="font-syne-bold">
                            {{ $t('dashboard.menu.PAYMENT') }}
                        </h1>
                    </v-col>
                </v-row>
                <v-row
                    v-show="dataLoad"
                    :class="[
                        {
                            'pl-0 pr-0': $vuetify.breakpoint.smAndDown,
                        },
                        { 'pl-16 pr-16 pb-16': $vuetify.breakpoint.mdAndUp },
                    ]"
                    cols="12"
                    :loading="dataLoading"
                >
                    <v-col>
                        <v-skeleton-loader
                            class="pt-2"
                            type="list-item-avatar-two-line"
                        />
                    </v-col>
                </v-row>
                <div v-show="!dataLoad && paymentList.length > 0">
                    <v-row
                        v-for="(payment, p) in paymentList"
                        :key="'payment-' + p"
                        :class="[
                            {
                                'pl-0 pr-0': $vuetify.breakpoint.smAndDown,
                            },
                            {
                                'pl-16 pr-16 pb-5': $vuetify.breakpoint.mdAndUp,
                            },
                        ]"
                    >
                        <v-col cols="3" md="1" class="pr-0">
                            <img
                                :src="payment.brand === 'visa' ? visa : master"
                            />
                        </v-col>
                        <v-col cols="5" md="8" class="pl-0">
                            <!-- PAYMENT DETAILS -->
                            <p class="font-metropolis-regular mb-0">
                                {{ cc }} {{ payment.last4 }}
                            </p>
                            <p
                                class="font-metropolis-regular font-12 text-grey mb-0"
                            >
                                {{ $t('form.expiryDate.text') }}
                                {{ payment.exp_month }}/{{ payment.exp_year }}
                            </p>
                        </v-col>
                        <v-col cols="2" class="text-right">
                            <!-- <v-btn
                                x-small
                                text
                                color="badge"
                                class="mt-5 lowercase"
                                @click="deletePayment(payment.id)"
                                >{{ $t('buttons.deletePaymentBtn') }}</v-btn
                            > -->
                            <v-btn
                                x-small
                                text
                                color="badge"
                                class="lowercase"
                                @click="goToPage(menus.SUBSCRIPTION.id)"
                                >{{ $t('buttons.viewSubscriptionBtn') }}</v-btn
                            >
                        </v-col>
                    </v-row>
                </div>
                <v-row
                    v-show="!dataLoad && paymentList.length === 0"
                    class="pl-16 pr-16 pb-16"
                >
                    <v-col cols="12"
                        ><p class="font-14 font-metropolis-regular text-white">
                            {{ $t('common.noPaymentDetails') }}
                        </p></v-col
                    >
                </v-row>

                <v-row
                    v-if="invoices.length >= 1"
                    :class="[
                        { 'pt-16 pl-0 pr-0': $vuetify.breakpoint.smAndDown },
                        { 'pl-16 pr-16': $vuetify.breakpoint.mdAndUp },
                    ]"
                >
                    <v-col cols="12">
                        <v-divider />
                    </v-col>
                    <v-col>
                        <h1 class="font-syne-bold">
                            {{ $t('dashboard.menu.INVOICES') }}
                        </h1>
                    </v-col>
                </v-row>
                <v-row
                    v-if="invoices.length >= 1"
                    :class="[
                        { 'pl-0 pr-0': $vuetify.breakpoint.smAndDown },
                        { 'pl-16 pr-16 pb-16': $vuetify.breakpoint.mdAndUp },
                    ]"
                >
                    <v-col cols="12">
                        <!-- INVOICES TABLE -->
                        <v-row>
                            <v-col cols="12">
                                <v-data-table
                                    :headers="headers"
                                    :items="invoices"
                                    item-key="id"
                                    :options.sync="options"
                                    :loading="dataLoading"
                                    class="elevation-1 transparent-bg font-metropolis-regular"
                                >
                                    <template v-slot:item.actions="{ item }">
                                        <v-btn
                                            x-small
                                            icon
                                            target="_blank"
                                            :href="item.pdf"
                                        >
                                            <v-icon> mdi-download </v-icon>
                                        </v-btn>
                                    </template>
                                </v-data-table>
                            </v-col>
                        </v-row>
                    </v-col>
                </v-row>
            </v-col>
        </v-row>
    </div>
</template>

<script lang="ts">
import { Vue, Component } from 'vue-property-decorator'
import { mapGetters } from 'vuex'
import { Debounce } from 'lodash-decorators'
import moment from 'moment'
import User from '~/utils/models/user'
import MenuBar from '~/components/dashboard/menuBar.vue'

Vue.component('menu-bar', MenuBar)

@Component<any>({
    middleware: ['authenticate'],
    head() {
        return {
            titleTemplate: '%s | ' + this.$t('dashboard.menu.HOME'),
            title: this.$t('dashboard.menu.PAYMENT'),
        }
    },
    computed: mapGetters({
        menus: 'menu/getMenuDashboard',
        user: 'user/getUser',
    }),
})
export default class Payment extends Vue {
    // Data
    menus!: any
    user!: User
    selectedPage: Number = 5 // payment
    dataLoad: Boolean = true
    dataLoading: Boolean = true
    visa: String = require('~/assets/images/visa.png')
    master: String = require('~/assets/images/mastercard.png')
    cc: String = '**** **** ****'
    ccExpiryDate: String = '11/2024'
    paymentList: any = []
    message: any = null
    color: String = ''
    icon: String = ''
    options = {
        page: 1,
        itemsPerPage: 5,
    }

    headers: any = [
        {
            text: this.$t('invoices.invoiceId'),
            align: 'start',
            sortable: false,
            value: 'id',
        },
        { text: this.$t('invoices.date'), value: 'date', sortable: false },
        { text: this.$t('invoices.amount'), value: 'total', sortable: false },
        {
            text: this.$t('invoices.status'),
            value: 'status',
            sortable: false,
        },
        {
            text: this.$t('invoices.invoice'),
            value: 'actions',
            sortable: false,
        },
    ]

    invoices: any = []

    // Watch
    /* @Watch('options')
    datatableHandler() {
        this.getInvoices()
    } */

    // Method
    goToPage(id: Number) {
        switch (id) {
            case this.menus.PAYMENT.sub.PAYMENTEDIT.id:
                this.$router.push(this.menus.PAYMENT.sub.PAYMENTEDIT.path)
                break

            case this.menus.SUBSCRIPTION.id:
                this.$router.push(this.menus.SUBSCRIPTION.path)
                break

            default:
                this.$router.push('/')
                break
        }
    }

    getInvoices() {
        this.dataLoading = true
        const { page, itemsPerPage } = this.options
        this.$api.user.invoices(itemsPerPage, page).then(({ data }) => {
            // Assign Item
            for (const item of data.data) {
                this.invoices.push({
                    id: item.id,
                    date: moment(item.created_at).format('DD/MM/YYYY HH:mm'),
                    pdf: item.pdf,
                    status: item.status.toUpperCase(),
                    total:
                        item.currency.toUpperCase() +
                        ' ' +
                        item.amount.toString(),
                })
            }

            this.dataLoading = false
        })
    }

    async getPaymentDetails() {
        const defaultPaymentDetails = await this.$api.payment.default()
        const paymentDetails = await this.$api.payment.payments()

        if (defaultPaymentDetails.data) {
            this.dataLoad = false
            this.dataLoading = false

            // Assign to payment array
            this.paymentList.push(defaultPaymentDetails.data)

            if (paymentDetails.data) {
                for (let p = 0; p < paymentDetails.data.length; p++) {
                    const index = paymentDetails.data.find(
                        (item) => item.id === paymentDetails.data[p].id
                    )

                    if (index === undefined) {
                        // assign to payment array
                        this.paymentList.push(paymentDetails.data[p])
                    }
                }
            }
        } else {
            this.dataLoad = false
            this.dataLoading = false
        }
    }

    @Debounce(500)
    async deletePayment(id: string) {
        if (!this.$cookies.get('t')) {
            this.message = this.$t('auth.unAuthenticate')
            this.color = 'red'
            this.icon = 'mdi-close-circle'
        } else {
            const deleteResponse = await this.$api.payment.deletePayment(
                id,
                this.user.id
            )

            if (deleteResponse) {
                const paymentIndex = this.paymentList.findIndex(
                    (payment) => payment.id === id
                )
                this.paymentList.splice(paymentIndex, 1)
                this.message = this.$t('notification.payment.removed')
                this.color = 'green'
                this.icon = 'mdi-check'
            }
        }

        const val = {
            text: this.message,
            color: this.color,
            icon: this.icon,
        }
        this.$store.dispatch('snackbar/displaySnackBar', val)
    }

    created() {
        this.$store.dispatch('menu/selectDashboardMenu', this.selectedPage)
        this.getInvoices()
        // Get payment details
        this.getPaymentDetails()
    }
}
</script>
